from netgen.meshing import *
from netgen.geom2d import unit_square

ngmesh = Mesh()
ngmesh.dim = 2

quads = True
xmin = 0
xmax = 3
Nx = 10
ymin = -1
ymax = 1
Ny = 10
pnums = []
for i in range(Nx + 1):
    for j in range(Ny + 1):
        pnums.append(ngmesh.Add(MeshPoint(Pnt(xmin + (xmax-xmin)*i / Nx, ymin + (ymax-ymin)*j / Ny,0))))


ngmesh.Add (FaceDescriptor(surfnr=1,domin=1,bc=1))
ngmesh.SetMaterial(1, "mat")

for j in range(Nx):
    for i in range(Ny):
        if quads:
            ngmesh.Add(Element2D(1, [pnums[i + j * (Ny + 1)],
                                     pnums[i + (j + 1) * (Ny + 1)],
                                     pnums[i + 1 + (j + 1) * (Ny + 1)],
                                     pnums[i + 1 + j * (Ny + 1)]]))
        else:
            ngmesh.Add(Element2D(1, [pnums[i + j * (Ny + 1)],
                                     pnums[i + (j + 1) * (Ny + 1)],
                                     pnums[i + 1 + j * (Ny + 1)]]))
            ngmesh.Add(Element2D(1, [pnums[i + (j + 1) * (Ny + 1)],
                                     pnums[i + 1 + (j + 1) * (Ny + 1)],
                                     pnums[i + 1 + j * (Ny + 1)]]))
cnt_ident = 1
# horizontal boundaries
for i in range(Nx):
   ngmesh.Add(Element1D([pnums[Ny + i * (Ny + 1)], pnums[Ny + (i + 1) * (Ny + 1)]], index=1))
   ngmesh.Add(Element1D([pnums[0 + i * (Ny + 1)], pnums[0 + (i + 1) * (Ny + 1)]], index=1))
   print(pnums[0 + i * (Ny + 1)]," -> ",pnums[Ny + i * (Ny + 1)])
   ngmesh.AddPointIdentification(pnums[0 + i * (Ny + 1)],pnums[Ny + i * (Ny + 1)],
                                 identnr=cnt_ident,type=2)
   
ngmesh.AddPointIdentification(pnums[0 + Nx * (Ny + 1)],pnums[Ny + Nx * (Ny + 1)],
                              identnr=cnt_ident,type=2)

cnt_ident += 1
# vertical boundaries
for i in range(Ny):
   ngmesh.Add(Element1D([pnums[i], pnums[i + 1]], index=2))
   ngmesh.Add(Element1D([pnums[i + Nx * (Ny + 1)], pnums[i + 1 + Nx * (Ny + 1)]], index=2))
   print(pnums[i]," -> ",pnums[i + Nx * (Ny + 1)])
   ngmesh.AddPointIdentification(pnums[i],pnums[i + Nx * (Ny + 1)],
                                 identnr=cnt_ident,type=2)

ngmesh.AddPointIdentification(pnums[Ny],pnums[Ny + Nx * (Ny + 1)],
                              identnr=cnt_ident,type=2)

# ngmesh.Save('quad_per.vol')

from ngsolve.solve import Draw
import ngsolve
mesh = ngsolve.Mesh(ngmesh)
Draw(mesh)
